!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Module MoistAdjust
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: moistadjust.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!˰Ĵˡ
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

Module MoistAdjust
  !
  !˰ĴˡԤΥѥå⥸塼
  !  * ˰¾Ȥؼ, 층Ū˼¹Ԥ
  !  * ȿˤĤƤ, 줾βȿ˼¹Ԥ. 

  !⥸塼ɤ߹
  use gridset, only:  SpcNum,           &!ؼο
    &                 DimXMin,          &! x β
    &                 DimXMax,          &! x ξ
    &                 DimZMin,          &! z β
    &                 DimZMax,          &! z ξ
    &                 RegXMin,          &! x ʪΰβ
    &                 RegXMax,          &! x ʪΰξ
    &                 RegZMin,          &! z ʪΰβ
    &                 RegZMax            ! z ʪΰξ
  use basicset, only: CpDry,            &
    &                 MolWtWet,         &
    &                 SpcWetID,         &
    &                 SpcWetSymbol,     &
    &                 xz_ExnerBasicZ,   &
    &                 xz_PotTempBasicZ, &
    &                 xz_MixRtBasicZ  
  use average,  only: xz_avr_pz, xz_avr_xr, pz_avr_xz, xr_avr_xz
  use ChemData, only: ChemData_OneSpcID
  use ChemCalc, only: SvapPress, LatentHeatPerMass,  &
    &                 xz_SvapPress, xz_LatentHeatPerMass, &
    &                 ReactHeatNH4SHPerMass
  use MoistFunc,only: Vap2MixRt, DMixRtSatDPotTemp, MixRt2Vap, &
    &                 xz_Vap2MixRt, xz_DMixRtSatDPotTemp, xz_MixRt2Vap, &
    &                 Exner2Press, DelMixRtNH4SH, &
    &                 xz_Exner2Press, xz_DelMixRtNH4SH

  !ۤηػ
  implicit none
  
  !°λ
  private

  !ؿ° public ѹ
  public MoistAdjust_Init        !롼
  public MoistAdjustSvapPress    !˰¾Ѥ˰¼Ĵ
  public MoistAdjustSvapPress2   !˰¾Ѥ˰¼Ĵ(ʰ)
  public MoistAdjustNH4SH        !ȿΰʿѤ˰¼Ĵ
  public MoistAdjustNH4SH2       !ȿΰʿѤ˰¼Ĵ

  !ѿ
  real(8)      :: MinError = 1.0d-12
  integer      :: LoopNum      = 0
  integer      :: GasNum(10)   = 0
  integer      :: CloudNum(10) = 0
  integer      :: NH3Num   = 0
  integer      :: H2SNum   = 0
  integer      :: NH4SHNum = 0
  
  save MinError
  save LoopNum, CloudNum, GasNum
  save NH3Num, H2SNum, NH4SHNum
  
contains

!!!------------------------------------------------------------------!!!
  subroutine MoistAdjust_Init( )
    !
    !׻Ѥ벽ؼ ID Ф
    !  * ȶŽ(γ) ID . 
    !  * NH4SH ȿ׻뤿, NH4SH  NH3, H2S  ID.

    !ۤηػ
    implicit none

    !ѿ
    integer                  :: s
    integer                  :: n1

    !-----------------------------------------------------------
    ! γȵΤ ID Ȥ
    !-----------------------------------------------------------
    !
    LoopNum = 0

    !ؼ椫γΤ, źʬ̤ݴ.
    SelectCloud: do s = 1, SpcNum

      ! NH4SH ˤĤƤ̵
      if ( trim(SpcWetSymbol(s)) == 'NH4SH-s-Cloud' ) then 
        cycle SelectCloud
      end if

      !'Cloud' Ȥʸ󤬴ޤޤΤθĿ
      n1 = index(SpcWetSymbol(s), '-Cloud' )
      if (n1 /= 0) then
        LoopNum          = LoopNum + 1
        CloudNum(LoopNum)= s
        GasNum(LoopNum)  = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID(SpcWetSymbol(s)(1:n1-3) // '-g'))
      end if
    end do SelectCloud
    
    !-----------------------------------------------------------
    ! β˥, ӥ˥βǤ ID 
    !-----------------------------------------------------------
    NH3Num   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH3-g'))
    H2SNum   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('H2S-g'))
    NH4SHNum = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH4SH-s'))

    !-----------------------------------------------------------
    ! ǧ
    !-----------------------------------------------------------
    if ( LoopNum == 0 ) then 
      write(*,*) "MoistAdjust: CloudNum = 0, please comment out of MoistAdjust"
!      stop
    end if

    write(*,*) "MoistAdjust_Init, LoopNum:  ", LoopNum
    write(*,*) "MoistAdjust_Init, CloudNum: ", CloudNum
    write(*,*) "MoistAdjust_Init, GasNum:   ", GasNum    
    write(*,*) "MoistAdjust_Init, NH3Num:   ", NH3Num
    write(*,*) "MoistAdjust_Init, H2SNum:   ", H2SNum
    write(*,*) "MoistAdjust_Init, NH4SHNum: ", NH4SHNum

  end subroutine MoistAdjust_Init


!!!------------------------------------------------------------------!!!
  subroutine MoistAdjustSvapPress(xz_Exner, xz_PotTemp, xz_MixRt ) 
    !
    ! ˰¾Ѥ˰Ĵˡμ¹
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !
    real(8) :: MixRtV_pre
    real(8) :: MixRtV_nxt
    real(8) :: MixRtC_pre
    real(8) :: MixRtC_nxt
    real(8) :: PotTemp_pre
    real(8) :: PotTemp_nxt    
    real(8) :: ExnerAll
    real(8) :: TempAll
    real(8) :: DelMixRt
    real(8) :: MixRtSat
    real(8) :: Gamma

    integer :: i, k, s, num          ! ź  
    
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    MixRtV_pre  = 0.0d0
    MixRtV_nxt  = 0.0d0
    MixRtC_pre  = 0.0d0
    MixRtC_nxt  = 0.0d0
    PotTemp_pre = 0.0d0
    PotTemp_nxt = 0.0d0
    
    ExnerAll    = 0.0d0
    TempAll     = 0.0d0
    DelMixRt    = 0.0d0
    MixRtSat    = 0.0d0 
    Gamma       = 0.0d0
    
    num   = 0
    
    !롼פ󤹤Τ, ˤĤƤ.  
    LoopSvapPress: do s = 1, LoopNum
!      write(*,*) 'pre: ', minval(xz_MixRt(:,:,GasNum(s))), maxval(xz_MixRt(:,:,GasNum(s)))
!      write(*,*) 'pre: ', minval(xz_MixRt(:,:,CloudNum(s))), maxval(xz_MixRt(:,:,CloudNum(s)))
            
      do k = RegZMin, RegZMax
        do i = RegXMin, RegXMax
          
          !˰ˡǤϰϤѲʤ. 
          ExnerAll = xz_Exner(i,k) + xz_ExnerBasicZ(i,k)
          
          !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
          MixRtV_pre  = xz_MixRt(i,k,GasNum(s))   + xz_MixRtBasicZ(i,k,GasNum(s))
          MixRtC_pre  = xz_MixRt(i,k,CloudNum(s)) + xz_MixRtBasicZ(i,k,CloudNum(s))
          PotTemp_pre = xz_PotTemp(i,k)
          
          !롼ײν
          num = 0
          
          Adjusting: do 
            !---------------------------------------------------------------
            ! ˰¾˰º
            !---------------------------------------------------------------
            !
            TempAll = (PotTemp_pre + xz_PotTempBasicZ(i,k)) * ExnerAll
            
            !˰¾˰º׻(ܾ줫κ). 
            MixRtSat = Vap2MixRt(MolWtWet(CloudNum(s)), SvapPress(SpcWetID(CloudNum(s)), TempAll), ExnerAll)
            
            !ʲ줿Ǯ
            Gamma = LatentHeatPerMass(SpcWetID(CloudNum(s)), TempAll) / (ExnerAll * CpDry)
            
            !---------------------------------------------------------------
            ! γؤѴԤ
            ! ʬ˰¾¿ or γ椬
            !---------------------------------------------------------------
            if (MixRtV_pre - MixRtSat > MinError .OR. MixRtC_pre > MinError) then
              
              !ŷ̤
              DelMixRt = ( MixRtV_pre - MixRtSat )                           &
                & / (1.0d0 + Gamma * DMixRtSatDPotTemp(SpcWetID(CloudNum(s)), MolWtWet(CloudNum(s)), TempAll, ExnerAll))
              
              PotTemp_nxt = PotTemp_pre + Gamma * DelMixRt
              MixRtV_nxt  = MixRtV_pre - DelMixRt
              MixRtC_nxt  = MixRtC_pre + DelMixRt
              
!              if( DelMixRt < 0.0d0 .AND. i == 50) write(*,*) MixRtV_nxt, MixRtSat, MixRtV_nxt - MixRtSat

              !̤«Ƥ鷫֤ߤ
              if (abs((PotTemp_nxt - PotTemp_pre) / PotTemp_nxt) <= MinError ) then 
                xz_PotTemp(i,k)          = PotTemp_nxt                 
                xz_MixRt(i,k,GasNum(s))   = MixRtV_nxt - xz_MixRtBasicZ(i,k,GasNum(s))
                xz_MixRt(i,k,CloudNum(s)) = MixRtC_nxt - xz_MixRtBasicZ(i,k,CloudNum(s))
                exit Adjusting
              end if
            
              !롼ײꤹ饨顼Ǥ³
              if ( num > 20 ) then 
                write(*,*) "Looping is too much, num > 20"
                xz_PotTemp(i,k)          = PotTemp_nxt     
                xz_MixRt(i,k,GasNum(s))   = MixRtV_nxt - xz_MixRtBasicZ(i,k,GasNum(s))
                xz_MixRt(i,k,CloudNum(s)) = MixRtC_nxt - xz_MixRtBasicZ(i,k,CloudNum(s))
                exit Adjusting
              end if
              
            else 
              
              !«Ȥƽλ
              !γ椬ˤʤäȤ, γˤ. 
              xz_PotTemp(i,k)          = PotTemp_pre - Gamma * MixRtC_pre
              xz_MixRt(i,k,GasNum(s))   = MixRtV_pre + MixRtC_pre - xz_MixRtBasicZ(i,k,GasNum(s))
              xz_MixRt(i,k,CloudNum(s)) = 0.0d0          
              exit Adjusting
            end if
            
            !---------------------------------------------------------------
            ! ֤Τѿ
            !---------------------------------------------------------------
            PotTemp_pre = PotTemp_nxt
            MixRtV_pre  = MixRtV_nxt
            MixRtC_pre  = MixRtC_nxt
            num         = num + 1
            
          end do Adjusting
          
        end do
      end do
 
!      write(*,*) 'nxt: ', minval(xz_MixRt(:,:,GasNum(s))), maxval(xz_MixRt(:,:,GasNum(s)))
!      write(*,*) 'nxt: ', minval(xz_MixRt(:,:,CloudNum(s))), maxval(xz_MixRt(:,:,CloudNum(s)))
    end do LoopSvapPress

    
  end subroutine MoistAdjustSvapPress

  
!!!------------------------------------------------------------------!!!
  subroutine MoistAdjustSvapPress2(xz_Exner, xz_PotTemp, xz_MixRt ) 
    !
    ! ˰¾Ѥ˰Ĵˡμ¹
    ! Υ롼Ǥ, ͽ᤿ȿɤԤ. 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !
    integer, parameter   :: ItrNum = 3                    !ȿɤβ
    real(8) :: xz_MixRtV_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtV_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtC_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtC_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PotTemp_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PotTemp_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_DelMixRt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtSat(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_Gamma(DimXMin:DimXMax, DimZMin:DimZMax) 
    integer :: i, s                                       ! ź  
    
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    xz_MixRtV_pre  = 0.0d0
    xz_MixRtV_nxt  = 0.0d0
    xz_MixRtC_pre  = 0.0d0
    xz_MixRtC_nxt  = 0.0d0
    xz_PotTemp_pre = 0.0d0
    xz_PotTemp_nxt = 0.0d0
    
    xz_ExnerAll    = 0.0d0
    xz_TempAll     = 0.0d0
    xz_DelMixRt    = 0.0d0
    xz_MixRtSat    = 0.0d0 
    xz_Gamma       = 0.0d0
    
    !---------------------------------------------------------------------
    ! ˰Ĵˡμ¹
    !   롼פ󤹤Τ, ˤĤƤ.  
    !---------------------------------------------------------------------
    LoopSvapPress: do s = 1, LoopNum
      
      !˰ˡǤϰϤѲʤ. 
      xz_ExnerAll = xz_Exner + xz_ExnerBasicZ
          
      !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
      xz_MixRtV_pre  = xz_MixRt(:,:,GasNum(s))   + xz_MixRtBasicZ(:,:,GasNum(s))
      xz_MixRtC_pre  = xz_MixRt(:,:,CloudNum(s)) + xz_MixRtBasicZ(:,:,CloudNum(s))
      xz_PotTemp_pre = xz_PotTemp
          
      Adjusting: do i = 0, ItrNum
        !---------------------------------------------------------------
        ! ˰¾˰º
        !---------------------------------------------------------------
        !
        xz_TempAll = (xz_PotTemp_pre + xz_PotTempBasicZ) * xz_ExnerAll

        !˰¾˰º׻(ܾ줫κ). 
        xz_MixRtSat = xz_Vap2MixRt( MolWtWet(CloudNum(s)), xz_SvapPress(SpcWetID(CloudNum(s)), xz_TempAll), xz_ExnerAll )
        
        !ʲ줿Ǯ
        xz_Gamma = xz_LatentHeatPerMass(SpcWetID(CloudNum(s)), xz_TempAll) / (xz_ExnerAll * CpDry)
        
        !ŷ̤. 
        !  ŷ뤬ˤ, xz_MixRtV_pre - xz_MixRtSat ɬͤȤʤ.
        !  ȯˤ, ȯ̤ - MixRtC Ķ뤳ȤϤʤ. 
        !  merge ؿѤƾȯ̤ξ¤Ƥ. 
        xz_DelMixRt = &
          & merge( &
          &    (xz_MixRtV_pre - xz_MixRtSat), &
          &    - xz_MixRtC_pre, &
          &    (xz_MixRtV_pre - xz_MixRtSat) > - xz_MixRtC_pre &
          &   ) &
          &   / (1.0d0 + xz_Gamma * xz_DMixRtSatDPotTemp( &
          &           SpcWetID(CloudNum(s)), MolWtWet(CloudNum(s)), xz_TempAll, xz_ExnerAll & 
          &        ) )
        
        !꿿˶ᤤͤ׻
        xz_PotTemp_nxt = xz_PotTemp_pre + xz_Gamma * xz_DelMixRt
        xz_MixRtV_nxt  = xz_MixRtV_pre  - xz_DelMixRt
        xz_MixRtC_nxt  = xz_MixRtC_pre  + xz_DelMixRt
        
        !֤Τѿ
        xz_PotTemp_pre = xz_PotTemp_nxt
        xz_MixRtV_pre  = xz_MixRtV_nxt
        xz_MixRtC_pre  = xz_MixRtC_nxt
        
      end do Adjusting
      
      !ȿɸͤ򿿤ͤȤݴ
      xz_PotTemp                = xz_PotTemp_nxt                 
      xz_MixRt(:,:,GasNum(s))   = xz_MixRtV_nxt - xz_MixRtBasicZ(:,:,GasNum(s))
      xz_MixRt(:,:,CloudNum(s)) = xz_MixRtC_nxt - xz_MixRtBasicZ(:,:,CloudNum(s))
      
    end do LoopSvapPress
    
  end subroutine MoistAdjustSvapPress2

  
!!!--------------------------------------------------------------------------!!!
  subroutine MoistAdjustNH4SH(xz_Exner, xz_PotTemp, xz_MixRt ) 
    !
    ! ȿΰʿ Kp Ѥ˰¼Ĵˡ
    ! , ߤ NH3 + H2S --> NH4SH ȿˤΤб
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !Žʬκ
    real(8) :: PotTemp_pre
    real(8) :: PotTemp_nxt
    real(8) :: MixRtNH3_pre
    real(8) :: MixRtNH3_nxt
    real(8) :: MixRtH2S_pre
    real(8) :: MixRtH2S_nxt
    real(8) :: MixRtNH4SH_pre
    real(8) :: MixRtNH4SH_nxt
    
    real(8) :: ExnerAll
    real(8) :: TempAll
    real(8) :: Gamma
    real(8) :: DelMixRt
    
    integer :: i, k, num          ! ź  
            
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    PotTemp_pre = 0.0d0
    PotTemp_nxt = 0.0d0
    MixRtNH3_pre   = 0.0d0
    MixRtNH3_nxt   = 0.0d0
    MixRtH2S_pre   = 0.0d0
    MixRtH2S_nxt   = 0.0d0
    MixRtNH4SH_pre = 0.0d0
    MixRtNH4SH_nxt = 0.0d0
    
    ExnerAll  = 0.0d0
    TempAll   = 0.0d0
    Gamma     = 0.0d0
    DelMixRt  = 0.0d0
    num       = 0
  
    do k = RegZMin, RegZMax
      do i = RegXMin, RegXMax

        !˰ˡǤϰϤѲʤ. 
        ExnerAll = xz_Exner(i,k) + xz_ExnerBasicZ(i,k)
        
        !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
        MixRtNH3_pre    = xz_MixRt(i,k,NH3Num)   + xz_MixRtBasicZ(i,k,NH3Num)
        MixRtH2S_pre    = xz_MixRt(i,k,H2SNum)   + xz_MixRtBasicZ(i,k,H2SNum)
        MixRtNH4SH_pre  = xz_MixRt(i,k,NH4SHNum) + xz_MixRtBasicZ(i,k,NH4SHNum)
        PotTemp_pre     = xz_PotTemp(i,k)
        
        !롼ײν
        num = 0
        
        AdjustNH4SH: do
          !---------------------------------------------------------------
          ! ѿν
          !---------------------------------------------------------------
          !
          TempAll = (PotTemp_pre + xz_PotTempBasicZ(i,k)) * ExnerAll
          
          !ʲ줿ȿǮ (NH4SH kg ФǮ)
          Gamma = ReactHeatNH4SHPerMass / (ExnerAll * CpDry)
          
          DelMixRt = DelMixRtNH4SH(TempAll, Exner2Press(ExnerAll),                         &
            &                      MixRtNH3_pre, MixRtH2S_pre, MixRtNH4SH_pre,             &
            &                      MolWtWet(NH3Num), MolWtWet(H2SNum), MolWtWet(NH4SHNum) )  

          !---------------------------------------------------------------
          ! 꿿˶ᤤͤ˰¾˰º
          !---------------------------------------------------------------
          ! NH4SH κ
          MixRtNH4SH_nxt  = MixRtNH4SH_pre + DelMixRt
          
          ! DelPress 򸵤, NH3  H2S κ
          MixRtNH3_nxt = MixRtNH3_pre - DelMixRt * MolWtWet(NH3Num) / MolWtWet(NH4SHNum)
          MixRtH2S_nxt = MixRtH2S_pre - DelMixRt * MolWtWet(H2SNum) / MolWtWet(NH4SHNum)
          
          !̤
          PotTemp_nxt = PotTemp_pre + Gamma * DelMixRt
          
!          if (k > 22 .AND. k < 24 .AND. i == 10) then 
!            write(*,*) 'CHECK'
!            write(*,*) num, i, k, DelMixRt
!            write(*,*) num, i, k, Gamma, Gamma * DelMixRt
!            
!            write(*,*) num, i, k, PotTemp_pre,    " --> ", PotTemp_nxt
!            write(*,*) num, i, k, MixRtNH3_pre,   " --> ", MixRtNH3_nxt
!            write(*,*) num, i, k, MixRtH2S_pre,   " --> ", MixRtH2S_nxt
!            write(*,*) num, i, k, MixRtNH4SH_pre, " --> ", MixRtNH4SH_nxt
!
!            write(*,*) 'pre', MixRtNH3_pre + MixRtH2S_pre + MixRtNH4SH_pre 
!            write(*,*) 'nxt', MixRtNH3_nxt + MixRtH2S_nxt + MixRtNH4SH_nxt 
!          end if
          
          !---------------------------------------------------------------
          ! «Ƚ
          !---------------------------------------------------------------
          !̤«Ƥ鷫֤ߤ
          if (abs((PotTemp_nxt - PotTemp_pre) / PotTemp_nxt) <= MinERROR   &
            & .OR. abs(PotTemp_nxt - PotTemp_pre) <= MinERROR             ) then 
            xz_PotTemp(i,k)         = PotTemp_nxt                 
            xz_MixRt(i,k,NH3Num)   = MixRtNH3_nxt - xz_MixRtBasicZ(i,k,NH3Num)
            xz_MixRt(i,k,H2SNum)   = MixRtH2S_nxt - xz_MixRtBasicZ(i,k,H2SNum)
            xz_MixRt(i,k,NH4SHNum) = MixRtNH4SH_nxt - xz_MixRtBasicZ(i,k,NH4SHNum)
            exit AdjustNH4SH
          end if
          
          !롼ײꤹ饨顼Ǥ³
          if ( num > 30 ) then 
            write(*,*) "Looping is too much, num > 30"
            write(*,*) "xz_PotTemp(i,k) ", i, k, PotTemp_nxt, PotTemp_pre
            xz_PotTemp(i,k)         = PotTemp_nxt                 
            xz_MixRt(i,k,NH3Num)   = MixRtNH3_nxt - xz_MixRtBasicZ(i,k,NH3Num)
            xz_MixRt(i,k,H2SNum)   = MixRtH2S_nxt - xz_MixRtBasicZ(i,k,H2SNum)
            xz_MixRt(i,k,NH4SHNum) = MixRtNH4SH_nxt - xz_MixRtBasicZ(i,k,NH4SHNum)
            exit AdjustNH4SH
          end if
          
          !֤Τѿ
          PotTemp_pre    = PotTemp_nxt
          MixRtNH3_pre   = MixRtNH3_nxt 
          MixRtH2S_pre   = MixRtH2S_nxt 
          MixRtNH4SH_pre = MixRtNH4SH_nxt 
          num            = num + 1
          
        end do AdjustNH4SH
      end do 
    end do 
    
  end subroutine MoistAdjustNH4SH


!!!--------------------------------------------------------------------------!!!
  subroutine MoistAdjustNH4SH2(xz_Exner, xz_PotTemp, xz_MixRt ) 
    !
    ! NH3 + H2S --> NH4SH ȿΰʿ Kp Ѥ˰¼Ĵˡ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !Žʬκ
    real(8) :: xz_PotTemp_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PotTemp_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH3_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH3_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtH2S_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtH2S_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH4SH_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH4SH_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    
    real(8) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_Gamma(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_DelMixRt(DimXMin:DimXMax, DimZMin:DimZMax) 
    
    integer            :: i
    integer, parameter :: ItrNum = 5
            
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    xz_PotTemp_nxt = 0.0d0
    xz_MixRtNH3_nxt   = 0.0d0
    xz_MixRtH2S_nxt   = 0.0d0
    xz_MixRtNH4SH_nxt = 0.0d0
    
    xz_Gamma     = 0.0d0
    xz_DelMixRt  = 0.0d0

    !˰ˡǤϰϤѲʤ. 
    xz_ExnerAll = xz_Exner + xz_ExnerBasicZ
        
    !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
    xz_MixRtNH3_pre(:,:)    = xz_MixRt(:,:,NH3Num)   + xz_MixRtBasicZ(:,:,NH3Num)
    xz_MixRtH2S_pre(:,:)    = xz_MixRt(:,:,H2SNum)   + xz_MixRtBasicZ(:,:,H2SNum)
    xz_MixRtNH4SH_pre(:,:)  = xz_MixRt(:,:,NH4SHNum) + xz_MixRtBasicZ(:,:,NH4SHNum)
    xz_PotTemp_pre          = xz_PotTemp
    
    AdjustNH4SH: do i = 1, ItrNum
      !---------------------------------------------------------------
      ! ѿν
      !---------------------------------------------------------------
      !
      xz_TempAll = ( xz_PotTemp_pre + xz_PotTempBasicZ ) * xz_ExnerAll
      
      !ʲ줿ȿǮ (NH4SH kg ФǮ)
      xz_Gamma = ReactHeatNH4SHPerMass / ( xz_ExnerAll * CpDry )

      !NH4SH 
      xz_DelMixRt = xz_DelMixRtNH4SH(xz_TempAll, xz_Exner2Press(xz_ExnerAll),           &
        &                      xz_MixRtNH3_pre, xz_MixRtH2S_pre, xz_MixRtNH4SH_pre,     &
        &                      MolWtWet(NH3Num), MolWtWet(H2SNum), MolWtWet(NH4SHNum) )  

      !---------------------------------------------------------------
      ! 꿿˶ᤤͤ˰¾˰º
      !---------------------------------------------------------------
      ! NH4SH κ
      xz_MixRtNH4SH_nxt  = xz_MixRtNH4SH_pre + xz_DelMixRt
      
      ! DelPress 򸵤, NH3  H2S κ
      xz_MixRtNH3_nxt = xz_MixRtNH3_pre - xz_DelMixRt * MolWtWet(NH3Num) / MolWtWet(NH4SHNum)
      xz_MixRtH2S_nxt = xz_MixRtH2S_pre - xz_DelMixRt * MolWtWet(H2SNum) / MolWtWet(NH4SHNum)
          
      !̤
      xz_PotTemp_nxt = xz_PotTemp_pre + xz_Gamma * xz_DelMixRt
      
      !롼פ󤹤ѿѲ
      xz_PotTemp_pre    = xz_PotTemp_nxt
      xz_MixRtNH3_pre   = xz_MixRtNH3_nxt 
      xz_MixRtH2S_pre   = xz_MixRtH2S_nxt 
      xz_MixRtNH4SH_pre = xz_MixRtNH4SH_nxt 

    end do AdjustNH4SH

    xz_PotTemp             = xz_PotTemp_nxt                 
    xz_MixRt(:,:,NH3Num)   = xz_MixRtNH3_nxt - xz_MixRtBasicZ(:,:,NH3Num)
    xz_MixRt(:,:,H2SNum)   = xz_MixRtH2S_nxt - xz_MixRtBasicZ(:,:,H2SNum)
    xz_MixRt(:,:,NH4SHNum) = xz_MixRtNH4SH_nxt - xz_MixRtBasicZ(:,:,NH4SHNum)
    
  end subroutine MoistAdjustNH4SH2
  
end Module MoistAdjust
